package com.gesoft.czreal;

import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.gesoft.czreal.common.base.BaseActivity;
import com.gesoft.czreal.common.bean.Method;
import com.gesoft.czreal.common.bean.MsgModel;
import com.gesoft.czreal.common.http.ActivityTaskPostExecute;
import com.gesoft.czreal.common.http.HttpTask;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class MainActivity extends BaseActivity {

    TextView tv_hello;
    Button btn_ok;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //setContentView(R.layout.activity_main);

        tv_hello = findViewById(R.id.tv_hello);
        btn_ok = findViewById(R.id.btn_ok);
        btn_ok.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Method method = new Method();
                method.setMethodName("/test/list");
                method.put("v", "v");
                addAutoLifecycleAsyncTask(new AutoLifecycleAsyncTaskBuilder() {
                    @Override
                    public AsyncTask build() {
                        return new HttpTask(MainActivity.this, method, "初使化数据...", new TestTask()).execute();
                    }
                });
            }
        });


    }

    @Override
    protected BaseActivity setActivity() {
        return this;
    }

    @Override
    protected void setContentView() {
        setContentView(R.layout.activity_main);
    }

    @Override
    protected List<AsyncTask> createList() {
        return new ArrayList<>();
    }

    private class TestTask implements ActivityTaskPostExecute<MainActivity> {
        @Override
        public void onPostExecuteActivity(MainActivity activity, MsgModel result) {
            if (result.isSuccess()){
                List<Map<String,Object>> data= (List<Map<String, Object>>) result.getData();
                tv_hello.setText(data.get(0).get("name").toString());
            }
        }
    }
}
